import { ComponentRef, DynamicComponentLoader, ApplicationRef } from '@angular/core';
export declare class MdToast {
    private loader;
    private hideDelay;
    private index;
    container: ComponentRef<any>;
    private appRef;
    constructor(loader: DynamicComponentLoader, appRef: ApplicationRef);
    /**
     * show toast
     * @param toastObj string or object with message and other properties of toast
     */
    show(toastObj: string | {
        message: string;
        hideDelay: number;
    }): void;
    /**
     * toast timeout
     * @param toastId
     */
    startTimeout(toastId: number): void;
    /**
     * setup toast
     * @param toast
     */
    setupToast(toast: Toast): void;
    /**
     * clear all toast
     * @param toastId
     */
    clear(toastId: number): void;
    /**
     * hide all or specific toasts
     */
    hide(): void;
}
export declare class Toast {
    id: number;
    message: string;
    constructor(message: string);
}
export declare const ACCORDION_DIRECTIVES: any[];
export declare class MdToastModule {
}
